#!/usr/bin/perl

die if !open(INFILE, "/home/vonkorff/build/informix_files/analysis_September_08/pulses_tail.txt");

die if !open(OUTFILE, ">analyze_radar.out");

while(<INFILE>) {
  # read db ap_signal output line
  if($_ =~ /^([\.\d]+)\|[\.\d-]+\|[\d]+\|[\d]+\|([\d-]+)/) {
    $peak_power = $1;
    $dm = $2; 
    # Is the signal a radar signal?
    if($peak_power < 95 && ($dm > 3000 || $dm < -3000)) { $is_radar = 0;}
    else {$is_radar = 1;}

    # read the next line, which is the filename
    $_ = <INFILE>;
    chomp $_;
    $filename = $_;

    # copy file into in.dat in current directory
    $cp = "cp $filename in.dat";
    ((system $cp) == 0) or die "cp command ($cp) failed\n";

    for($randomize = 0; $randomize <= 1 ; $randomize++) {

      # clean up stderr.txt, pulse.out, etc.
      $cleanupscript = "cleanupscript";
      ((system $cleanupscript) == 0) or die "cleanupscript command ($cleanupscript) failed\n";

      # run ap_client
      $ap_client = "../ap_client -full_dm" . abs($dm) . " -debug_msg -skipffa_long -skipffa_short";
      if($randomize) { $ap_client .= " -remove_radar"; }
      ((system $ap_client) == 0) or die "ap_client command ($ap_client) failed\n";

      # check for pulses
      die if !open(PULSEOUT, "pulse.out");

      $pulses_present = 0;

      while(<PULSEOUT>) {
        if($_ =~ /<pulses>/) {
          $_ = <PULSEOUT>;
          if($_ =~ /<\/pulses>/) { $pulses_present = 0; }
          else { $pulses_present = 1; }
          break;
        }
      }

      close PULSEOUT;

      if(!$randomize) {
        if(!$pulses_present) { print OUTFILE "Problem in $filename, no pulses found in non-randomized data.\n"; }
        else { print OUTFILE "Obtained expected result in $filename, pulses found in non-randomized data.\n"; }
      } else {
        if(!$pulses_present && $is_radar) { print OUTFILE "Obtained expected result in $filename, no pulses found in randomized radar data\n"; }
        if(!$pulses_present && !$is_radar) { print OUTFILE "Problem in $filename, no pulses found in randomized non-radar data\n"; }
        if($pulses_present && $is_radar) { print OUTFILE "Problem in $filename, pulses found in randomized radar data\n"; }
        if($pulses_present && !$is_radar) { print OUTFILE "Obtained expected result in $filename, pulses found in randomized non-radar data\n"; }
      }
    }
  }
}

