// Copyright 2007 Regents of the University of California

// SETI_BOINC is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2, or (at your option) any later
// version.

// SETI_BOINC is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.

// You should have received a copy of the GNU General Public License along
// with SETI_BOINC; see the file COPYING.  If not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

// In addition, as a special exception, the Regents of the University of
// California give permission to link the code of this program with libraries
// that provide specific optimized fast Fourier transform (FFT) functions and
// distribute a linked executable.  You must obey the GNU General Public 
// License in all respects for all of the code used other than the FFT library
// itself.  Any modification required to support these libraries must be
// distributed in source code form.  If you modify this file, you may extend 
// this exception to your version of the file, but you are not obligated to 
// do so. If you do not wish to do so, delete this exception statement from 
// your version.
//
#include "ctype.h"
#include "stdio.h"
#include <string>
#include "db_table.h"

#include "ap_config.h"
#include "ap_schema.h"

#include "ap_const.h"

#include "ap_time_series.h"

namespace Astropulse {

#ifndef ENUM_CODE_SEGMENT_NAME
#define ENUM_CODE_SEGMENT_NAME
enum code_segment_name {main_ffa_long, main_ffa_short, build_threshold_table_long, build_threshold_table_short, single_pulse};
#endif

};


#include "ap_state.h"
#include "gdata.h"
#include "boinc_api.h"

extern REDUCED_ARRAY_GEN rarray;
extern AP_GDATA* ap_graphics;
extern bool nographics_flag;

inline bool nographics() {return nographics_flag;}
extern void ap_graphics_init(APP_INIT_DATA&);
