// #include "ap_config.h"

#ifdef _WIN32
#include "windows.h"
#endif

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <iostream>
#include <sstream>
#include <algorithm>

// #include <ctype.h>

// #include "setilib.h"
// #include "db_table.h"
// #include "sqlhdr.h"
// #include "schema_master.h"
// #include "seti_doppler.h"
#include "parse.h"
#include "xml_util.h"
#include "db_table.h"
#include "ap_schema.h"
// #include "astropulse.h"
#include "util.h"
#include "base64.h"
#include "ap_raw_data_db.h"
#undef read

#include <cstring>
#include <cassert>
#include <cstdlib>
#include <cstdio>
#include <cerrno>
#include <ctime>
#include <cmath>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#include <stdlib.h>
#endif

int main(int argc, char* argv[]) {

// Handle command line arguments

bool not_rfi = false;
long ap_signalid = -1;
char * db_name = "apb_db@sci_master_tcp";  // will change later if found in command line

std::string where_clause = "";
char c_string[100];

/* Possible arguments:
 *  -ap_signalid	mark the signal with this id
 *  -not_rfi	mark the signal as not rfi
 *  -db_name	the name of the database we'll be connecting to.
 */
for (int i=1; i<argc; i++) {
    if (!strncmp(argv[i], "-ap_signalid", 12)) {
      ap_signalid = atoi(argv[i] + 12);
      fprintf(stderr, "marking ap_signalid: %d<br>\n", ap_signalid);
    }
    else if (!strcmp(argv[i], "-not_rfi")) {
      not_rfi = true;
      fprintf(stderr, "marking not_rfi<br>\n");
    }
    else if (!strncmp(argv[i], "-db_name", 8)) {
      db_name = argv[i] + 8;
      fprintf(stderr, "Running with db: %s<br>\n", db_name);
    }
}

setenv("INFORMIXDIR", "/disks/thumper/a/apps/informix", 1);
setenv("INFORMIXSQLHOSTS", "/disks/thumper/a/apps/informix/etc/sqlhosts", 1);
setenv("INFORMIXSERVER", "sci_master_tcp", 1);

int retval = db_change(db_name);
fprintf(stderr, "db_change(%s) returns %d\n", db_name, retval);

rfi this_rfi;
sprintf(c_string, "where ap_signalid = %ld", ap_signalid);
where_clause = c_string;
this_rfi.open_query(where_clause, "", "{--+first_rows}");
if(!this_rfi.get_next()) {
    fprintf(stderr, "Error : can't find rfi with ap_signalid %ld.<br>\n", ap_signalid);
    exit(0);
}
if(not_rfi) this_rfi.user_marked = 0;
else this_rfi.user_marked = 1;
this_rfi.user_marked_time = time(NULL);
this_rfi.update();

if(not_rfi)
    fprintf(stderr, "Marked ap_signal %ld as not rfi.<br>\n", this_rfi.ap_signalid.id);
else
    fprintf(stderr, "Marked ap_signal %ld as rfi.<br>\n", this_rfi.ap_signalid.id);

this_rfi.close_query();

}
